/*
   $Id: bitcount.h 649 2011-10-31 13:57:42Z manu $
*/
/*
 * Copyright INRA/CNRS - Thomas.Faraut@toulouse.inra.fr, Emmanuel.Courcelle@toulouse.inra.fr
 * This software is a computer program whose purpose is to align nucleic sequences, or perform other utility tasks
 * This software is governed by the CeCILL-C license under French law and abiding by the rules of distribution of free software.
 * 
 * Please read the file Licence_CeCILL-C_V1-en.txt which should have been distributed with this file
 * The fact that you are presently reading this, and the aforementioned file, means that you have had
 * knowledge of the CeCILL-C license and that you accept its terms.
*/
/* ==========================================================================
   Bit Counting routines

   Algo by Gurmeet Singh Manku    (manku@cs.stanford.edu)
   Adapted to a new singleton class by Emmanuel courcelle (emmanuel.courcelle@toulouse.inra.fr)
   Date:   27 Aug 2002
   ========================================================================== */


#ifndef __BITCOUNT_H__
#define __BITCOUNT_H__

#include "ptypes.h"

class BitCount: public Singleton<BitCount> {
protected:
    BitCount();

public:
	int GetBitCount( uint64_t ) const;
	friend class Singleton<BitCount>;
	
private:
	char bits_in_16bits [0x1u << 16] ;
	int __iterated_bitcount (unsigned int n);
};
		
#endif
